#!/usr/bin/tclsh

# cut head 'n' line to avoid 峭,JangnanHotIssue, ȣõ, .
set cut_head_nline 4
set head_line 0
# cut tail 'n' line to print how many lines
set cut_tail_nline 3
set tail_line 1

# read http, htmlparse package to use http/parsing function
package require http
lappend auto_path /usr/local/lib/tcllib1.7
package require htmlparse

# read RecentChanges and convert it's language to readable korean
set url "http://jangnan.st/wiki/RecentChanges"
set token [::http::geturl $url]
set html [::http::data $token]
set html [encoding convertfrom cp949 $html]

# delete old debugfile
file delete list.txt

# filtering function that choose last changed document
proc callback {tag slash param textbehind} {
	global cut_head_nline head_line cut_tail_nline tail_line
	if {[string equal $tag "a"] && [string equal $slash ""] && [regexp {^href*} $param] && ![string equal $textbehind ""]} {
		if {$head_line < $cut_head_nline} {
			incr head_line
			return 0
		} elseif {$tail_line > [expr 2 * $cut_tail_nline] } {
			return 0
		} else {
			incr tail_line
		}

		set STDOUT [open "list.txt" a]
		puts $STDOUT "<$tag> <$slash> <$param> <$textbehind>"
		close $STDOUT
	}
}

# parsing html with above filter
::htmlparse::parse -cmd callback $html
