# Deal each event with following options.

puts -nonewline "Loading [info script] ..."

# Join channel
$cn registerevent 001 {
    #$cn nick $krnick
    #$cn join $channel
    $ircclient::cn nick $ircclient::KorNick
    foreach channel $ircclient::channels {
	$ircclient::cn join $channel
    }
    $ircclient::cn privmsg $ircclient::Admin "$ircclient::KorNick 񽺸 մϴ."
}

# Register a default action for commands from the server.
$cn registerevent defaultcmd {
    puts "[action] [msg]"
}

# Register a default action for numeric events from the server.
$cn registerevent defaultnumeric {
    puts "[action] XXX [target] XXX [msg]"
    if { [action] == "353" } {
	if { [catch {source channel_userlist.tcl} error_reason] } {
	    puts "ERROR@353_äȮ: $error_reason"
	}
    }
}

# Register a default action for events.
$cn registerevent defaultevent {
    puts "[action] XXX [who] XXX [target] XXX [msg]"

    # Response for event. Detail operation is specified on rfc1495 4.2.3 Mode message.
    if {[string equal [action] "MODE"]} {
    } elseif {[string equal [action] "PART"]} {
    } elseif {[string equal [action] "JOIN"]} {
	# Make welcome message except for foxbear
	if {[string compare [who] $ircclient::KorNick] != 0} {
	    $ircclient::cn privmsg [target] " [who] ."
	}
	# Exceptional process for administrator
	if {[string equal [who] $ircclient::Admin]} {
	    # See the l.1141 of rfc1495 reference
	    $ircclient::cn mode [target] "+o" $ircclient::Admin
	}
    }
}

# Register a default action for PRIVMSG (either public or to a channel).
# Take a exception processing for bad procedure

$cn registerevent PRIVMSG {
    puts "[who] says to [target] [msg]"

    # Response for private message
    if {[string equal [target] $ircclient::KorNick]} {
	# Response for Administrator's private message
	if {[string equal [who] $ircclient::Admin]} {
	    if {[regexp {^ư*} [msg]] & [regexp {!$} [msg]]} {
		$ircclient::cn privmsg $ircclient::Admin "$ircclient::KorNick 񽺸 Ĩϴ."
		$ircclient::cn destroy
	    }
	}
    } elseif {[string equal [msg] ""]} {
	$ircclient::cn privmsg [target] "[who]/ !"
    } elseif {[string equal [msg] "ֱ峭?"]} {
	if { [catch {source get_jangnan_recently.tcl} error_reason] } {
	    puts "ERROR@ֱ峭: $error_reason"
	}

	$ircclient::cn privmsg [target] "=== 峭Ű ֱ  === http://jangnan.st/moniwiki/wiki.php/RecentChanges"
	foreach listitem $list_jangnan_recently {
	    $ircclient::cn privmsg [target] "$listitem"
	}
    } elseif {[string equal [msg] "ÿ!"] || [string equal [msg] "!ÿ"]} {
	if { [catch {source all_op.tcl} error_reason] } {
	    puts "ERROR@ÿ: $error_reason"
	}
    } elseif {[regexp {} [msg]] & [regexp {[!?]$} [msg]]} {
	if { [catch {source weather.tcl} error_reason] } {
	    puts "ERROR@: $error_reason"
	}
    }
}
# Puts loading end message
puts " done"
