#!/usr/bin/tclsh

package require http

proc URL_Fetch {url} {
    set tok [http::geturl $url]
    set res [http::data $tok]
    http::cleanup $tok
    return $res
}

# read weather rss's list
if [ catch { open "weather_fetchaddress.txt" r } weather_rsslistfile ] {
    puts "ERROR@: $weather_rsslistfile"
} else {
    set weather_rsslist [read -nonewline $weather_rsslistfile]
    close $weather_rsslistfile
}

# find a location to know the weather, using [msg].
# if not defined, set the location to Seoul
set location [regsub -all {[(?)|?|.|!|\ ]} [msg] {}]
if {$location == ""} {
    set location ""
}
#puts "ã: $location"

# find requested location and its rss url. if not founded, set the location to seoul.
if {[lsearch $weather_rsslist "*$location*"] != -1} {
    set weather_rss [lsearch $weather_rsslist "*$location*"]
    set weather_location [lindex $weather_rsslist $weather_rss]
    incr weather_rss
    set weather_rss [lindex $weather_rsslist $weather_rss]
    #     puts "ã: $weather_location"
    #     puts "rss: $weather_rss"

    # read data, then parse it!
    set weather_rssdata [URL_Fetch $weather_rss]

    # parsing
    set weather_flag_contentstype "null"
    foreach {- item} [regexp -all -inline {<td(.*?)</td>} $weather_rssdata] {
	#     puts "======================"
	#     puts $item
	#     puts "======================"

	# when there's no expectation for datas
	if {$weather_flag_contentstype == "null"} {
	    if {[string first "" $item] != -1} {
		# pasing and logging
		set item [string range $item [string first "" $item] [string length $item]]
		lappend list_weather_data $item

		# set the flag to store that datas to memory
		set weather_flag_contentstype "today_weather"

		# Debugging 
		#	    puts "===== $item ====="
	    } elseif {[string first "" $item] != -1} {
		# pasing and logging
		set item [string range $item [string first "" $item] [string length $item]]
		lappend list_weather_data $item

		# set the flag to store that datas to memory
		set weather_flag_contentstype "tomorrow_weather"

		# Debugging 
		#	    puts "===== $item ====="
	    }
	    
	} else {
	    # when there's expectation that following data will be some weather information

	    # pasing and logging
	    set item [string range $item [expr [string first ">" $item] + 2] [string length $item]]
	    set item [regsub -all {<br>} $item {, }]
	    lappend list_weather_data "$item"

	    # clean the flag, after weather data logging
	    set weather_flag_contentstype "null"

	    # Debugging
	    # 	puts $item
	    # 	puts "======================"
	} 
    }

    # Debugging
    #     foreach {when how} $list_weather_data {
    # 	puts "$when -> $how"
    #     }

    # Inform the weather
    $ircclient::cn privmsg [target] "<> $weather_location"
    foreach {when how} $list_weather_data {
	$ircclient::cn privmsg [target] "$when -> $how"
    }
} else {
    $ircclient::cn privmsg [target] "[who] /  ʴ Դϴ."
}